 #include "L298PMotorShield.h"
L298PMotorShield::L298PMotorShield() {
  BT_TX=1;
  BT_RX=0;

  _BUZZER = 4;

  _Trig = 7;
  _Echo = 8;

  servoPin = 9;

  _INA = 12; //1번 모터 Enable
  _PWMA = 10; //1번 모터 pwm
  _INB = 13; //2번 모터 Enable
  _PWMB = 11; //2번 모터 pwm
}

void L298PMotorShield::defaultSetting(){
  pinMode(_INA, OUTPUT);
  pinMode(_INB, OUTPUT);

  pinMode(_Trig, OUTPUT);
  pinMode(_Echo, INPUT);

  pinMode(_BUZZER, OUTPUT);
 }

// set speed for left motor,speed between -400 to 400
void L298PMotorShield::setM1Speed(int speed)
{
  unsigned char reverse = 0;

  if(speed < 0)
  {
    speed = -speed; //make speed a positive quantity
    reverse = 1;  //reverse the direction
  }
  if(speed > 255)
    speed = 255;

  //analogWrite(_PWMA,speed * 51 / 80); // default to using analogWrite, mapping 400 to 255
  analogWrite(_PWMA,speed);

  if (reverse)
    digitalWrite(_INA,LOW);
  else
    digitalWrite(_INA,HIGH);
}

//set speed for motor right
void L298PMotorShield::setM2Speed(int speed)
{
  unsigned char reverse = 0;

  if (speed < 0)
  {
    speed = -speed;  // Make speed a positive quantity
    reverse = 1;  // Preserve the direction
  }
  if (speed > 400)  // Max PWM dutycycle
    speed = 400;

  analogWrite(_PWMB,speed * 51 / 80); // default to using analogWrite, mapping 400 to 255

  if (reverse)
    digitalWrite(_INB,LOW);
  else
    digitalWrite(_INB,HIGH);
}

//set speed for motor left and right
void L298PMotorShield::setSpeeds(int m1speed, int m2speed)
{
  setM1Speed(m1speed);
  setM2Speed(m2speed);
}

//부져소리
void L298PMotorShield::setBuzzerSound(bool k){
  if(k==TRUE) digitalWrite(_BUZZER, HIGH);
  else digitalWrite(_BUZZER, LOW);
}

//초음파센서거리값
float L298PMotorShield::getDistance(){
  float Duration, Distance;
  digitalWrite(_Trig,HIGH);
  delay(10);
  digitalWrite(_Trig,LOW);

  Duration = pulseIn(_Echo, HIGH);
  Distance = (Duration/29) /2;
  return Distance;
}
